# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/org/jboss/xnio/xnio-nio/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free
%define reltag .GA
%global namedversion %{version}%{?reltag}

Name:           jboss-xnio-base
Version:        1.2.1
Release:        6%{?dist}
Epoch:          0
Summary:        XNIO low level IO layer
Group:          Development/Libraries/Java
License:        LGPLv2+
URL:            http://jboss.org/xnio/
# svn export http://anonsvn.jboss.org/repos/xnio/xnio-base/tags/1.2.1.GA/ jboss-xnio-base-1.2.1.GA
# Exported revision 376.
# tar czf jboss-xnio-base-1.2.1.GA.tar.gz jboss-xnio-base-1.2.1.GA
Source0:        jboss-xnio-base-1.2.1.GA.tar.gz
Source1:        jboss-xnio-base-component-info.xml
Source2:        jboss-xnio-base-settings.xml
Patch0:         jboss-xnio-base-build.patch
Patch1:         jboss-xnio-base-build-properties.patch
Patch2:         jboss-xnio-base-policy.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       java >= 0:1.5.0
Requires:       jaxb_2_1_api
Requires:       jboss-common-core
Requires:       jboss-microcontainer2
Requires:       jbossxb2
Requires:       jpackage-utils
BuildRequires:  ant
BuildRequires:  ant-junit
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  jpackage-utils
BuildRequires:  junit
BuildRequires:  jaxb_2_1_api
BuildRequires:  jboss-common-core
BuildRequires:  jboss-microcontainer2
BuildRequires:  jbossxb2
BuildRequires:  maven2-plugin-deploy
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
XNIO is a simplified low-level I/O layer which can be used 
anywhere you are using NIO today. It frees you from the 
hassle of dealing with Selectors and the lack of NIO support 
for multicast sockets and non-socket I/O such as serial 
ports, while still maintaining all the capabilities present 
in NIO. Also, XNIO vastly simplifies implementation of 
channels, opening the door to supporting higer-level 
transport concepts (like SSL or virtual channels) with the 
same simple API.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n %{name}-%{namedversion}
%patch0 -p0 -b .sav0
%patch1 -p0 -b .sav1
%patch2 -p0 -b .sav2

mkdir -p .jboss/repository/sun-jaxb/2.0.5/lib/
cp $(build-classpath jaxb_2_1_api) .jboss/repository/sun-jaxb/2.0.5/lib/jaxb-api.jar

mkdir -p .jboss/repository/jboss-common-core/2.2.0.GA/lib/
cp $(build-classpath jboss-common-core) .jboss/repository/jboss-common-core/2.2.0.GA/lib/jboss-common-core-2.2.0.GA.jar

mkdir -p .jboss/repository/jboss-microcontainer/2.0.0.Beta11/lib/
cp $(build-classpath jboss-microcontainer2/jboss-kernel) .jboss/repository/jboss-microcontainer/2.0.0.Beta11/lib/jboss-kernel.jar

mkdir -p .jboss/repository/jbossxb/2.0.0.CR5/lib/
cp $(build-classpath jbossxb2) .jboss/repository/jbossxb/2.0.0.CR5/lib/jboss-xml-binding.jar

mkdir -p .jboss/repository/junit/3.8.1/lib/
cp $(build-classpath junit) .jboss/repository/junit/3.8.1/lib/junit.jar

cp -p %{SOURCE2} settings.xml
sed -i -e "s|<url>__INTERNAL_REPO_PLACEHOLDER__</url>|<url>file:`pwd`/m2_repo/repository</url>|g" settings.xml
sed -i -e "s|<url>__EXTERNAL_REPO_PLACEHOLDER__</url>|<url>file:`pwd`/external_repo</url>|g" settings.xml

%build
export OPT_JAR_LIST=`cat %{_sysconfdir}/ant.d/junit`
export CLASSPATH=
%{ant} all jar test javadoc

%install
rm -rf %{buildroot}

# jars
install -d -m 755 %{buildroot}%{_javadir}/jboss-xnio
cp -p xnio-api.jar %{buildroot}%{_javadir}/jboss-xnio/xnio-api-%{namedversion}.jar
cp -p xnio-nio.jar %{buildroot}%{_javadir}/jboss-xnio/xnio-nio-%{namedversion}.jar
(cd %{buildroot}%{_javadir}/jboss-xnio && for jar in *-%{namedversion}*; do ln -s ${jar} `echo $jar| sed  "s|-%{namedversion}||g"`; done)

export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
rm -rf ${MAVEN_REPO_LOCAL}
mkdir -p ${MAVEN_REPO_LOCAL}
%{_bindir}/mvn-jpp deploy:deploy-file -s settings.xml -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
    -DgroupId=org.jboss.xnio -DartifactId=xnio-api -Dversion=%{namedversion} -Dpackaging=jar -Dfile=%{buildroot}%{_javadir}/jboss-xnio/xnio-api-%{namedversion}.jar \
    -Durl=file:%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew -DrepositoryId=jboss-releases
%{_bindir}/mvn-jpp deploy:deploy-file -s settings.xml -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
    -DgroupId=org.jboss.xnio -DartifactId=xnio-nio -Dversion=%{namedversion} -Dpackaging=jar -Dfile=%{buildroot}%{_javadir}/jboss-xnio/xnio-nio-%{namedversion}.jar \
    -Durl=file:%{buildroot}%{_javadir}/repository.jboss.com//maven2-brew -DrepositoryId=jboss-releases

# javadoc
mkdir -p %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
cp -pr docs/target/main/javadoc/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
ln -s %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

# poms
mkdir -p %{buildroot}%{_datadir}/maven2/poms
cp -p %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/org/jboss/xnio/xnio-api/%{namedversion}/xnio-api-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.jboss-xnio-xnio-api.pom
%add_to_maven_depmap org.jboss.xnio xnio-api %{namedversion} JPP/jboss-xnio xnio-api
cp -p %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/org/jboss/xnio/xnio-nio/%{namedversion}/xnio-nio-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.jboss-xnio-xnio-nio.pom
%add_to_maven_depmap org.jboss.xnio xnio-nio %{namedversion} JPP/jboss-xnio xnio-nio

%if %with repolib
mkdir -p %{buildroot}%{repodir}
mkdir -p %{buildroot}%{repodirlib}
cp -p %{SOURCE1} %{buildroot}%{repodir}/component-info.xml
tag=`echo %{namedversion}-brew`
sed -i "s/@VERSION@/$tag/g" %{buildroot}%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
mkdir -p %{buildroot}%{repodirsrc}
cp -p %{SOURCE0} %{buildroot}%{repodirsrc}
cp -p %{PATCH0} %{buildroot}%{repodirsrc}
cp -p %{PATCH1} %{buildroot}%{repodirsrc}
cp -p %{PATCH2} %{buildroot}%{repodirsrc}
cp -p %{buildroot}%{_javadir}/jboss-xnio/xnio-api-%{namedversion}.jar %{buildroot}%{repodirlib}/jboss-xnio-xnio-api.jar
cp -p %{buildroot}%{_javadir}/jboss-xnio/xnio-nio-%{namedversion}.jar %{buildroot}%{repodirlib}/jboss-xnio-xnio-nio.jar
cp -p %{buildroot}%{_datadir}/maven2/poms/JPP.jboss-xnio-xnio-api.pom %{buildroot}%{repodirlib}/jboss-xnio-xnio-api.pom
cp -p %{buildroot}%{_datadir}/maven2/poms/JPP.jboss-xnio-xnio-nio.pom %{buildroot}%{repodirlib}/jboss-xnio-xnio-nio.pom
%else
rm -r %{buildroot}%{_javadir}/repository.jboss.com
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}*/jboss-xnio
%{_javadir}*/jboss-xnio/xnio-api-%{namedversion}.jar
%{_javadir}*/jboss-xnio/xnio-api.jar
%{_javadir}*/jboss-xnio/xnio-nio-%{namedversion}.jar
%{_javadir}*/jboss-xnio/xnio-nio.jar
%{_datadir}/maven2/poms/JPP.jboss-xnio-xnio-api.pom
%{_datadir}/maven2/poms/JPP.jboss-xnio-xnio-nio.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Thu Mar 31 2011 David Walluck <dwalluck@redhat.com> 0:1.2.1-6
- fix repolib option
- update License
- update BuildRoot
- Requires: jpackage-utils for main pkg and javadoc pkg
- fix dir ownership in main pkg and repolib pkg
- no bundled jars to remove
- fix patch macros
- don't mark javadoc as %%doc
- update %%defattr
- end repolib description with a dot
- call ant properly
- fix maven deps
- fix component-info.xml sed
- use full version in jar and javadoc dir names
- fix repolib permissions
- use proper macro for build root
- remove bundled bare poms
- use proper mvn-jpp deploy:deploy-file
- use settings.xml for mvn-jpp
- update jboss-xnio-base-build.patch

* Thu Mar 31 2011 Fernando Nasser <fnasser@redhat.com> - 0:1.2.1-5
- Rebuild due to signing failure in the last build

* Fri Dec 10 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.2.1-4
- Add maven2-brew contents to repolib

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.2.1-3.1
- rebuilt

* Mon Apr 19 2010 Yiqiao Wang <yiwang@redha.com> - 0:1.2.1-3
- Rebuild

* Thu Nov 12 2009 Yong Yang <yyang@redhat.com> - 0:1.2.1-2
- Add repolib

* Fri Sep 18 2009 Fernando Nasser <fnasser@redhat.com> - 0:1.2.1-1
- Upgrade to 1.2.1.GA

* Mon Aug 31 2009 Ralph Apel <r.apel at r-apel.de> - 0:1.2.0-1
- First release
